######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

# boules.pyde
# Exercice 11.59 c)

from random import randint

R1 = 20       # rayons des boules
R2 = 40
M1 = R1**2    # prenons une masse égale au carré du rayon par exemple...
M2 = R2**2
Ms = M1 + M2
Md = M1 - M2

def setup():
    size(400,100)
    global x1, v1, x2, v2
    x1 = 20 ; v1 = 6      # la boule 1 est à gauche, vitesse vers la droite
    x2 = 200 ; v2 = -3    # la boule 2 est à droite, vitesse vers la boule 1
    fill(0)

def draw():
    global x1, v1, x2, v2
    background(255,255,0)
    line(0,height/2,width,height/2)                # le fil tendu
    ellipse(x1,height/2,2*R1,2*R1)
    ellipse(x2,height/2,2*R2,2*R2)
    (xs1, xs2) = (x1 + v1, x2 + v2)  # candidat position suivante
    if xs1 < R1:                     # collision boule1 mur gauche
        xs1 = R1
        v1 = -v1                     # collision élastique...
    elif xs2 > width - R2:           # collision boule 2 mur droit
        xs2 = width - R2
        v2 = -v2
    else:
        d = (xs2 - xs1) - (R1 + R2)  # distance des points d'impact
        if d >= 0:
            x1 = xs1
            x2 = xs2
        else:
            (x1,x2) = (x1+d/2,x2-d/2)
            (v1,v2) = ((Md*v1 + 2*M2*v2)/Ms,(2*M1*v1 - Md*v2)/Ms)  # SAGE...



    
