#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_alphabet.py (11.38)
Construction de la chaîne A contenant l'alphabet minuscule
"""

def alphabet() :
    res = ''
    for i in range(ord('a'),ord('z')+1) :
        res = res + chr(i)
    return res

if __name__ == '__main__':
    A = alphabet()
    print('A =',A)
    print('A =',repr(A))    # pour voir la chaîne avec ses apostrophes...
    # une solution un peu plus "pythonesque" :
    AP = ''.join(map(chr,range(ord('a'),ord('z')+1)))
    print('AP =',repr(AP))
