#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_csv.py (11.118)
Les fichiers au format CSV (par ex. export d'un tableur)
"""

f_in = open('feuille.csv','r')
print("J'ouvre le fichier 'feuille.csv'.")

# on pourrait placer les dimensions de la matrice sur la première ligne,
# mais ici on sait qu'il s'agit d'une matrice 3 x 3

M = []
for i in range(3):
    ligne = f_in.readline().replace(',','.')        # nous sommes en France...
    M.append(list(map(float,ligne.split(';'))))     # je sais que le séparateur est un ';'
print('La matrice 3x3 est :')
print('M =',M)
print("J'importe le module mat1.py")
print()
from exo_mat1 import mat_dim, mat_mul, mat_repr
print('Notre matrice M est de format {} :\n{}'.format(mat_dim(M),mat_repr(M)))
print()
print('et son carré est :\n{}\n'.format(mat_repr(mat_mul(M,M))))

# COMPLEMENTS EN LIGNE
from webbrowser import open as browse
#browse('https://fr.wikipedia.org/wiki/Comma-separated_values')





