#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_fich1.py (11.116)
Ecriture dans un fichier texte
"""

from random import randint, random

def fichier_nombres(f):
    '''Construit un fichier texte contenant 10 lignes de nombres aléatoires
    entiers ou flottants.'''
    f_in = open(f,'w')                 # encoding = 'UTF-8'
    for i in range(10):
        for i in range(2,7):
            if randint(0,1) == 0:      # 1 chance sur 2
                f_in.write('{} '.format(randint(0,100)))
            else :
                f_in.write('{} '.format(randint(0,99)+random()))
        f_in.write('\n')
    f_in.close()

def fichier_nombres(f):                # idem, en utilisant "with"
    '''Construit un fichier texte contenant 10 lignes de nombres aléatoires
    entiers ou flottants.'''
    with open(f,'w') as f_in:          # encoding = 'UTF-8'
        for i in range(10):
            for i in range(2,7):
                if randint(0,1) == 0:  # 1 chance sur 2
                    f_in.write('{} '.format(randint(0,100)))
                else:
                    f_in.write('{} '.format(randint(0,99)+random()))
            f_in.write('\n')
    # le descripteur de fichier f_in a été fermé.

if __name__ == '__main__':
    fichier_nombres('nombres.txt')    # le fichier a été créé
    import os
    print('Vérification :', 'nombres.txt' in os.listdir('.'))

    # COMPLEMENTS EN LIGNE
    from webbrowser import open as browse
    #browse('https://docs.python.org/fr/3/library/functions.html#open')
    #browse('https://docs.python.org/3/tutorial/inputoutput.html#reading-and-writing-files')




