#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_lambda.py (11.11)
Une variable locale dans une lambda ? Un peu snob mais...
"""

# En principe, une lambda-fonction ne contient qu'une seule expression.
# Mais on peut emboîter les expressions :-)
# Recodage donc de la fonction g avec une lambda, pour le fun...
 
g = lambda x,n: (lambda a: (a + (a+1)**n)) (x*x)

print('g(3,2) =', g(3,2))

# COMPLEMENTS EN LIGNE
# Cet exercice-jouet montre l'idée du "lambda-calcul" de Church :
from webbrowser import open as browse
#browse('https://fr.wikipedia.org/wiki/Lambda-calcul') # pour les spartiates...
#browse('http://lambdaway.free.fr/lambdaspeech/')      # page web avec lambda ?