#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_perceptrons_xor.py (11.134)
Implémentation de la fonction logique XOR à l'aide de trois perceptrons
dont deux sur une couche cachée.
"""

from exo_perceptron1 import Perceptron

def xor(x1,x2):
    global p_A, p_B, p_S
    p_A = Perceptron(Lpoids=[-1,2,2])
    p_B  = Perceptron(Lpoids=[3,-2,-2])
    p_S = Perceptron(Lpoids=[-3,2,2])
    sortie_A = p_A.reponse([x1,x2])
    #print('  x1={} et x2={}, sortie_A={}'.format(x1,x2,sortie_A))
    sortie_B = p_B.reponse([x1,x2])
    #print('  x1={} et x2={}, sortie_B={}'.format(x1,x2,sortie_B))
    sortie_S = p_S.reponse([sortie_A,sortie_B])
    return sortie_S

if __name__ == '__main__':
    print('Le réseau implémente bien un XOR :')
    for x in (0,1):
        for y in (0,1):
            print(x,'xor',y,'=',xor(x,y))     # ok pour xor
    print('\nA implémente bien un OR :')
    for x in (0,1):
        for y in (0,1):
            print(x,'or',y,'=',p_A.reponse([x,y]))     # ok pour A = OR
    print('\nB implémente bien un NAND :')
    for x in (0,1):
        for y in (0,1):
            print(x,'nand',y,'=',p_B.reponse([x,y]))     # ok pour B = NAND
    print('\nS implémente bien un AND :')
    for x in (0,1):
        for y in (0,1):
            print(x,'and',y,'=',p_S.reponse([x,y]))     # ok pour S = AN
    
            

             
