#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_return.py (11.4)
Distinguer les fonctions avec ou sans résultat.
"""

def somme_car_2max_v1(a,b,c):
    '''Retourne la somme des carrés des deux plus grands arguments (int ou float)'''
    mini = min(a,b,c)
    maxi = max(a,b,c)
    median = a + b + c - mini - maxi
    return median * median + maxi * maxi

if somme_car_2max_v1(3,2,8) != 73 :
    print('La fonction somme_car_2max_v1 est fausse !')

def somme_car_2max_v2(a,b,c):        # sans utiliser min et max
    '''Retourne la somme des carrés des deux plus grands arguments (int ou float)'''
    if a < b:
        if c < a: return a * a + b * b
        else: return b * b + c * c
    else:
        if c < b: return a * a + b * b
        else: return a * a + c * c

if somme_car_2max_v2(3,2,8) != 73 :
    print('La fonction somme_car_2max_v2 est fausse !')

def print_somme_car_2max(a,b,c):    # résultat : None (<==> pas vraiment de résultat)
    print('Somme des carrés des deux plus grands parmi',a,b,c,':',end=' ')
    print(somme_car_2max_v1(a,b,c))

res = print_somme_car_2max(3,2,8)
print('res vaut',res)                # print_somme_car_deux_max a un EFFET, pas un RESULTAT

    

