#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_toursin.py (11.52)
Un panier d'oursin, vite à table !
"""

# -------------------------------------------------------------

from turtle_init import *    # fichier d'utilitaires tortue qui ajoute :
# from turtle import *
# init(x=0,y=0,cap=0)
# afficher(msg,x,y)
# sleep(dt)            en secondes flottantes
# deg_rad(a_degrés)    conversion degrés -> radians
# rot(M,K,a_degrés)    K = centre de rotation
# segment(M1,M2)       le tracé d'un segment
# pi, sqrt, sin, cos, randint   pour les calculs fréquents

from random import randint

def oursin(n,c):                # avec n épines
    for i in range(n):
        d = randint(c//4,c)     # de longueur aléatoire dans [c/3,c]
        forward(d)
        back(d)
        left(2*randint(0,359)/2)    # je plante les épines au hasard

getcanvas().focus_force()           # getcanvas() --> la fenêtre graphique
reset()
bgcolor(0.6,1,0.75)  # dans le mode "1.0" par défaut, sinon colormode(255)...
init(0,0,0)
tracer(False)        # pour dessiner vite (en fait dans la carte graphique)
for i in range(15):
    up() ; goto(randint(-250,250),randint(-250,250)) ; down()
    oursin(1500,100)
tracer(True)         # pour "vider la carte graphique"

mainloop()
print('Fini')


