#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_2_21.py
03/03/2020
"""
print('Quelques exemples de code du §2.21')
print()

### ligne 310

def somme(a,b):
    '''Prend deux entiers a et b et retourne la somme des
    entiers de l'intervalle [a,b].'''
    return sum(range(a,b+1))         # range est un objet itérable

print('>>> somme(1,100)',somme(1,100),sep='\n--> ')
print('>>> help(somme)')
help(somme)
print('---------------------')

### ligne 322

def somme(a,b):     # a,b entiers. Retourne la somme a+(a+1)+...+b
    return sum(range(a,b+1))         # range est un objet itérable

print('>>> somme(1,10)',somme(1,10),sep='\n--> ')

# bien entendu, somme(a,b) == (b-a+1)*(a+b)/2 si a <= b      [ok ?]
from random import randint
a = randint(1,1000)
b = randint(a,1000)
if somme(a,b) != (b-a+1)*(a+b)//2:
    print('Oups')
else:
    print('On récupère au passage un théorème gratuit :')
    print('   (b-a+1)*(a+b) est toujours pair pour tous a <= b entiers !')
    # euh, ce qui est évident puisque a+b et a-b ont même parité :-)

