#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_2_24.py
03/03/2020
"""
print('Quelques exemples de code du §2.24')
print()

def fac_while(n):              # calcul ITERATIF de n! pour n >= 0
    res = 1                    # initialisation du résultat
    i = 2                      # initialisation d'un compteur
    while i <= n:              # boucle "tant que"
        res = res * i          #   mise à jour...
        i = i + 1              #   ...des variables de boucle
    return res                 # et retour du résultat

if __name__ == '__main__':
    print('>>> fac_while(5)\n-->',fac_while(5))
    print('>>> len(str(fac_while(50000)))\n-->', len(str(fac_while(50000))))   # pas de pile

# --------------- une version plus propre ---------------
    
def fac_while(n):              
    res = 1
    while n > 0:
        (n,res) = (n-1,res*n)  # calcule n*(n-1)*(n-2)*...*1
    return res

if __name__ == '__main__':
    print()
    print('# avec la version plus propre :')
    print('>>> fac_while(5)\n-->',fac_while(5))
    print('>>> len(str(fac_while(50000)))\n-->', len(str(fac_while(50000))))   # pas de pile




