#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_3_5.py
03/03/2020
"""

print('Quelques exemples de code du §3.5')
print()

# ligne 573

from math import *
print('>>> from math import *')
print(">>> s = 'x + sqrt(2)' ; x = 3")
s = 'x + sqrt(2)' ; x = 3
print('>>> eval(s)\n-->',eval(s))    # ok
print()

# ligne 577

def val0():                  # calcul interactif d'une valeur en 0
    f = eval(input("Entrez une fonction d'arité 1 (cos, lambda x:2*x, etc) : "))
    print('Sa valeur en 0 est',f(0))   # DANGEUREUX. L'UTILISATEUR PEUT ENTRER UNE
                                       # FONCTION OCCASIONNANT DES DEGATS SUR VOTRE
                                       # MACHINE : ATTAQUE PAR INJECTION DE CODE.
                                       # VOIR : "Le danger de la forme eval(input(...))"
                                       # A LA PAGE 62.

val0()
print()

# ligne 583

def oups():
    global m
    m = m + 1                              # "effet de bord" sur m, beurk !

m = 3
print('>>> m\n-->',m)
print(">>> oups()\n-->",eval('oups()'))
print('>>> m\n-->',m,'     oups !')
print(">>> eval('abs(-m)',{'m':10}) + m\n-->",eval('abs(-m)',{'m':10}) + m)
print(">>> eval('sqrt(abs(-m))')\n-->",eval('sqrt(abs(-m))'))
print(">>> eval('abs(-5)',{'__builtins__':None})")
try:
    eval('abs(-5)',{'__builtins__':None})
except:
    print("TypeError: 'NoneType' object is not subscriptable")
print(">>> eval('m',{'__builtins__':None})")
try:
    eval('m',{'__builtins__':None})
except:
    print("TypeError: 'NoneType' object is not subscriptable")
print(">>> eval('sqrt(abs(-m))')\n-->",eval('sqrt(abs(-m))'))
print(">>> eval('1+2',{'__builtins__':None})\n-->",eval('1+2',{'__builtins__':None}))
print()

# ligne 603
AUT = {'sqrt':sqrt,'m':m,'abs':abs}      # autorisations
print(">>> AUT = {'sqrt':sqrt,'m':m,'abs':abs}")
print(">>> eval('sqrt(abs(-m))',{'__builtins__':None},AUT)\n-->",
      eval('sqrt(abs(-m))',{'__builtins__':None},AUT))



