#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_5_3.py
03/03/2020
"""

print('Quelques exemples de code du §5.3')
print()

# ligne 781

print('>>> [i*i for i in range(11)]')
print('-->',[i*i for i in range(11)])
print('>>> [i*i for i in range(11) if i % 2 == 0]')
print([i*i for i in range(11) if i % 2 == 0])
print('>>> [(i,j) for i in range(2) for j in range(3)]')
print([(i,j) for i in range(2) for j in range(3)])
print('>>> [x for L in [(1,2),[3,4],(5,6)] for x in L]')
print([x for L in [(1,2),[3,4],(5,6)] for x in L])
print('>>> sum(i*i for i in [3,2,5,4,6,1] if i % 2 == 0)')
print(sum(i*i for i in [3,2,5,4,6,1] if i % 2 == 0))
print()

# ligne 791

it = map(lambda x: x*x,range(11))    # un itérateur
print('Itérateurs\nmap : ',end='')
for x in it :                        # sur lequel on peut itérer :-)
    print(x,end=' ')
print()
itf = filter(lambda x: x < 10, [5,18,12,9,10,7])
print('filter : ',end='')
print(list(itf))
print('        ',list(itf),'    (épuisé !)')
print()

# ligne 804

print('Module itertools')
from itertools import permutations
print('>>> list(permutations([1,2,3]))\n-->',
      list(permutations([1,2,3])))
print()

print('Module functools')
from functools import reduce
print('>>> reduce(lambda acc,x: acc*x, [1,2,3,4,5])\n-->',
      reduce(lambda acc,x: acc*x, [1,2,3,4,5]))

