#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_5_7.py
03/03/2020
"""

print('Quelques exemples de code du §5.7')
print()

print('Les ensembles.')

# ligne 888

e1 = {6,9,3,1}                              # construction en extension
e2 = {k for k in range(10) if k % 2 == 1}   # construction en compréhension
e3 = set('azerty')                          # et à partir d'un itérable
print('>>> e1\n-->',e1)
print('>>> e2\n-->',e2)
print('>>> e3\n-->',e3)
print(">>> 'y' in e3\n-->",'y' in e3)
print('>>> len(e1)\n-->',len(e1))
print()

# ligne 901

print('e1 == {3,1,9,6,9,6}\n-->',e1 == {3,1,9,6,9,6})
print()

# ligne 903

print('6 in e1  ==',6 in e1)
print('e1 | e2 ==',e1 | e2)
print('e1 & e2 ==',e1 & e2)
print('e1 - e2 ==',e1 - e2)
print()

# ligne 911

e1.pop()
print('Après e1.pop(), e1 ==',e1)
print()

# ligne 915

e1.add(9)
print('Après e1.add(9), e1 ==',e1)
e1.add(9)
print('Après encore une fois e1.add(9), e1 ==',e1)
print()

# ligne 921

e1.discard(6)
print('Après e1.discard(6), e1 ==',e1)
e1.discard(4)
print('Après e1.discard(4), e1 ==',e1)
print()

# ligne 924

print('>>> (e1 & e2) <= e1\n-->',(e1 & e2) <= e1)
print()

# ligne 926

print('>>> {1, 2, {1,2}}')
try:
    f = {1, 2, {1,2}}
except TypeError:
    print("TypeError: type non hashable: 'set'")
    print("# Un ensemble ne peut pas être élément d'un ensemble.")
    



    