#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_6_1.py
03/03/2020
"""

print('Quelques exemples de codes du §6.1 - Le module os')
print()

# ligne 1009

import os, platform, sys
print('>>> os.name\n-->',repr(os.name))
if os.name == 'posix' :
    print('# Donc vous êtes sous un système Unix (Linux ou MacOS).')
else:
    print('Donc vous êtes sous Windows.')
print('# Système :',platform.system())
print('#   version :',platform.mac_ver())
print('# Implémentation Python :',platform.python_implementation())
print('#   version :',sys.version) 
print()

# ligne 1018

print(">>> os.path.join('..','photos','lion.jpg')\n-->",
      repr(os.path.join('..','photos','lion.jpg')))   # dépend du système...

print(">>> p = os.path.join('..','photos','animaux','lion.jpg')")
p = os.path.join('..','photos','animaux','lion.jpg')
print('>>> p\n-->',repr(p))
print('>>> os.path.split(p)\n-->',os.path.split(p))
print()

print('>>> os.getcwd()    # répertoire de travail\n-->',repr(os.getcwd()))

import subprocess
print('# ou avec un appel système :\n',
      subprocess.run(['pwd'],capture_output=True).stdout)
print()


from webbrowser import open as browse
#browse('https://docs.python.org/fr/3/library/os.html')
#browse('https://docs.python.org/fr/3/library/platform.html')
#browse('https://docs.python.org/fr/3/library/sys.html')
#browse('https://docs.python.org/fr/3/howto/unicode.html')
