#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_7_6.py
03/03/2020
"""

print('Quelques exemples de codes du §7.6')
print("(objets en soft, générateurs du pauvre)")
print()

print("Il s'agit surtout de comprendre l'idée d'envoi de message")
print('et non de simuler yield dans toute sa généralité...')
print('Un objet est essentiellement une fonction qui reçoit un')
print('message !')
print()

def gen_entiers(n=0):
    '''Retourne un objet générateur d'entiers à partir de n.'''
    # n est une variable privée de la fermeture self
    def self(méthode,*args):
        nonlocal n
        if méthode == 'etat' : return n
        elif méthode == 'suiv' : n = n + 1 ; return n - 1
        elif méthode == 'init' : n = args[0]
        elif méthode == 'reset' : self('init',0)     # appel à moi
        else : raise TypeError('Inconnu : {}'.format(méthode))
    return self

gen = gen_entiers(5)
print(">>> for i in range(5) : print(gen('suiv'),end=' ')")
for i in range(5) : print(gen('suiv'),end=' ')
print()
print(">>> gen('suiv')\n-->",gen('suiv'))
print(">>> gen('suiv')\n-->",gen('suiv'))
print(">>> gen('suiv')\n-->",gen('suiv'))
print(">>> gen('etat')\n-->",gen('etat'))    # le prochain produit...
print(">>> gen('reset')\n-->",gen('reset'))  # remise à zéro
print(">>> gen('etat')\n-->",gen('etat'))
print(">>> gen('init',10)\n-->",gen('init',10))
print(">>> gen('suiv')\n-->",gen('suiv'))
print(">>> gen('suiv')\n-->",gen('suiv'))

