#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_8_4.py
03/03/2020
"""

print('Quelques exemples de codes du §8.4')
print("(le module requests et l'arpentage du Web)")
print()

import requests, re

URL = 'http://www.stellar-database.com/Scripts/search_star.exe?Name='
MOTIF = re.compile(r'Proper names:</B> (.+)\r')

def les_noms(star):
    with requests.get(URL + star) as reponse:
        #print(reponse.status_code)                # 200 <==> OK
        #print('Encoding :',reponse.encoding)
        #print(reponse.headers)
        texte = reponse.text
        sol = re.search(MOTIF,texte)
        if sol : return sol[1]

if __name__ == '__main__':
    print('Les noms de Vega : {}'.format(les_noms('Vega')))
    print()
    print('Les noms de Sirius : {}'.format(les_noms('Sirius')))

    # COMPLEMENTS EN LIGNE
    from webbrowser import open as browse
    #browse('http://docs.python-requests.org/en/master/')
    #browse('https://www.youtube.com/watch?v=_8HPCToXdAk')
    #browse('http://www.stellar-database.com/Scripts/search_star.exe?Name=Vega')


