#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

'''
section_9_1_7.py
03/03/2020
'''

print('Quelques exemples de codes du §9.1.7')
print('(les boutons-radio et les variables de contrôle)')
print()

from tkinter import *

ROOT = Tk()
ROOT.geometry('200x100+80+80')    # taille 200x100, coin haut gauche en (80,80)
ROOT.title('Boutons radio')

# "Variable de contrôle" contenant une string (valeur du bouton enclenché)
svar  = StringVar()

# L'enfoncement d'un bouton radio provoque la mise à jour de la variable de
# contrôle, et inversement.
RADIOS = Frame(ROOT)         # le conteneur des boutons radio
b1 = Radiobutton(RADIOS,text='rouge',variable=svar,value='red')
b2 = Radiobutton(RADIOS,text='noir',variable=svar,value='black')
b3 = Radiobutton(RADIOS,text='bleu',variable=svar,value='blue')
b4 = Radiobutton(RADIOS,text='vert',variable=svar,value='green')
for b in (b1,b2,b3,b4) : b.pack(fill=X)
RADIOS.pack(side=LEFT)
# la même svar pour les quatre boutons-radio et le label
LABEL = Label(ROOT,textvariable=svar,font=('Times',40,'bold'))
LABEL.pack(expand=1)

svar.set('blue')
print('Valeur du bouton radio enclenché au départ :',svar.get())
ROOT.focus_force()

ROOT.mainloop()       # pour exec. au Terminal
print('Fini')

from webbrowser import open as browse
#browse('http://tkinter.fdex.eu/doc/ctrvar.html')


