######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

# Exercice 11.127 du livre.
# Le programme de poursuite est mis en place dans le setup et s'execute en boucle
# dans le draw avec un frameRate normalement (par defaut) proche de 60 img/sec.

from tortue import X0, Y0, distance, Tortue     # l'onglet 'tortue.py' est le module 'tortue'

print("L'origine tortue est en ({},{})".format(X0,Y0))    # le print de "Python 2"

# Pas besoin de donner des noms de variables aux tortues, elles sont enregistrees 
# dans la liste Tortue.tortues...
Tortue(x=-X0,y=Y0,cap=90)            # Blinky
Tortue(x=X0,y=Y0,cap=180)            # Pinky
Tortue(x=X0,y=-Y0,cap=270)           # Inky
Tortue(x=-X0,y=-Y0,cap=0)            # et Clyde :-)

L = Tortue.tortues                   # un alias de la liste de toutes les tortues

def setup():
    global i
    size(2*X0,2*Y0)                  # initialisation de la fenêtre graphique
    strokeWeight(3)                  # epaisseur du crayon 
    background(255,255,0)            # couleur du fond (jaune)
    i = 0                            # numero de la tortue active

def draw():
    global i          # c'est a la tortue numero i de jouer !
    j = (i+1) % 4     # i poursuit sa suivante j
    if distance(L[i],L[j]) < 4:
        # affichage de la vitesse d'animation (frameRate)
        print 'frameRate =', frameRate, 'img/sec. Impact !'   # le print de "Python 2"...
        # sauvegarde du dessin dans le dossier du sketch
        saveFrame('four-bugs.png')
        # et terminaison de la boucle d'animation
        noLoop()
    L[i].toward(L[j].pos())
    L[i].forward(3)
    i = j

# https://www.openprocessing.org
