######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

# beads_c    -  Le bruit blanc.
# Exercice 11.137 c)

add_library('beads')
ac = AudioContext()
jaune = color(255,255,0)
noir = color(0,0,0)

def setup():
    size(512, 200)
    stroke(jaune) ; strokeWeight(2)
    n = Noise(ac)
    g = Gain(ac,1,0.5)
    g.addInput(n)
    ac.out.addInput(g)
    ac.start()
    print('Buffer size :',ac.getBufferSize())

def draw():
    background(noir)
    # calcul et affichage d'un tampon
    (xp,yp) = (0,height/2)
    for x in range(width):
        # ramenons la taille du tampon a une largeur de width
        buffIndex = x * ac.getBufferSize() / width
        # et calculons la hauteur de l'echantillon en ce point
        # avec un axe Ox au milieu vertical de la fenetre.
        y = int((1+ac.out.getValue(0, buffIndex)) * height / 2)
        y = min(y, height)
        set(x,y,jaune)   # ou line(xp,yp,x,y) ; (xp,yp) = (x,y)
    #noLoop()    # décommentez cette ligne pour une image fixe
    
def stop():
    ac.stop()

    
