#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_addstrbin.py (11.47)
Addition de chaînes binaires à la main, avec retenue.
"""

def add_strbin(s1,s2):
    '''Retourne sous forme de chaine l'addition binaire des chaines
    binaires s1 et s2'''
    # alignement (padding) des deux chaînes
    n1 = len(s1) ; n2 = len(s2)
    if n1 < n2: s1 = (n2-n1) * '0' + s1
    else: s2 = (n1-n2) * '0' + s2
    # maintenant je suis certain que len(s1) == len(s2)
    # mais les variables n1 et n2 sont devenues inutilisables !
    ret = 0       # la retenue courante
    res = ''      # la chaîne résultat
    for i in range(1,len(s1)+1):
        # -i pour aller de droite à gauche !
        a = int(s1[-i]) + int(s2[-i]) + ret      
        ret = a // 2
        res = str(a % 2) + res
    # et à la fin :
    if ret == 1: res = '1' + res
    return res

if __name__ == '__main__':
    print('   101110\n+   11101\n---------\n=',add_strbin('101110','11101'))
    print('Vérification :',end=' ')
    print(0b101110 + 0b11101 == eval('0b' + add_strbin('101110','11101')))
