#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_invmots.py (11.62)
Inversion de l'ordre des mots dans une phrase.
"""

def invmots(s):
    '''Prend une phrase dans une chaîne s et retourne la phrase
    avec les mêmes mots mais à l'envers'''
    L = s.split()        # on coupe la phrase aux espaces, L est une liste de chaînes
    L.reverse()          # on inverse la liste L sur place
    return ' '.join(L)   # et on recolle les mots dans une chaîne, séparés par un espace

if __name__ == '__main__':
    print(">>> invmots('je cours sur la plage')\n-->",
          repr(invmots('je cours sur la plage')))
    if invmots("J'ai faim !") != "! faim J'ai":
        print('Bug dans invmots !')

