#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_onze_et_onze.py (11.18)
d'après 'La Recherche', Mai 2019 (Pierre Berloquin)
"""

# Quels opérateurs parmi + - * / % insérer entre les nombres 11
# pour valider ces équations ?
# 11  11  11  11  =  0
# 11  11  11  11  =  1
# 11  11  11  11  =  2
# 11  11  11  11  =  3
# 11  11  11  11  =  10
# 11  11  11  11  =  11
# 11  11  11  11  =  12

def solve(somme):     # en utilisant eval pour éviter la prise de tête...
    '''Résoud l'égalité "11 op1 11 op2 11 op3 11 == somme" où les
    opérateurs op sont parmi + - * / %'''
    cpt = 0
    ops = {'+', '-', '*', '/', '%'}
    for op1 in ops:
        for op2 in ops:
            for op3 in ops:
                s = '11 ' + op1 + ' 11 ' + op2 + ' 11 ' + op3 + ' 11'
                if eval(s) ==  somme:
                    print(s,'==',somme)
                    cpt += 1
    print('soit',cpt,'possibilité(s) pour la somme',somme,'\n')

for somme in {0,1,2,3,10,11,12}:
    solve(somme)

