#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_rand2.py (11.25)
Entiers aléatoires et dés truqués
"""

from exo_rand1 import monte_carlo, las_vegas 

def test_tirage(n,tirage,p1,p2,p3) :     # tirage() jette un dé à 3 faces 2,3,5
    '''Teste le comportement d'un de truque avec la fonction tirage.
    p1, p2, p3 sont les probas theoriques.'''
    n2 = n3 = n5 = 0              # nombres de succès sur 2, 3, 5
    for i in range(n) :
        hasard = tirage()
        if hasard == 2 : n2 += 1
        elif hasard == 3 : n3 += 1
        else : n5 += 1
    print('Probas trouvées   :',(n2/n, n3/n, n5/n))
    print('Probas théoriques : ({:.2f}, {:.2f}, {:.2f})'.format(p1,p2,p3))

# On lance 50_000 fois chaque dé
print('monte_carlo :')
test_tirage(50_000,monte_carlo,1/3,1/3,1/3)
print()
print('las_vegas :')
test_tirage(50_000,las_vegas,1/6,1/3,1/2)




