#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_resist.py (11.6)
Décomposer en sous-fonctions
"""

# Je définis de petites fonctions auxilliaires

def serie(r1,r2) :               # résistors en série
    return r1 + r2

def parallele(r1,r2) :           # résistors en parallèle
    return r1 * r2 / (r1 + r2)   # 1/(1/r1 + 1/r2)

def circuit(r1,r2,r3,r4) :       # le circuit dessiné
    return serie(r1,parallele(serie(r2,r3),r4))

# Résister à la tentation de tout coder dans une seule fonction.
# Faire apparaître la structure de la solution...

print('La résistance totale du circuit est',circuit(5,20,25,80),'ohms')
print('La résistance totale du circuit est',circuit(5,20,25,80),'\u03a9')  # Unicode...

