######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2019) ###
######################################################################

# Fichier pour le chapitre 10.

// Fichier illustrant l'importance des sous-classes anonymes
// pour faire des fonctions des objets à passer en arguments,
// technique utilisee souvent par Evan Merz dans ses fichiers
// d'exemples sur Beads. Voir la "Lesson03FMSynthesis".

public abstract class Fonction {
  protected float x = 10;                    // protected : passe aux sous-classes
  public abstract float calcule(float t);    // méthode abstraite à concrétiser dans une sous-classe
}

Fonction f = new Fonction() {        // sous-classe anonyme (a la volée)
  public float calcule(float t) {    // implémentation de la méthode calcule
    return t*t + x;                  // x est visible !
  }
};

void setup() {                       // invoquée automatiquement par Processing (sorte de 'main'...)
  System.out.println("f.calcule(2) --> " + f.calcule(2));    // 14.0
}

  
