#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
mouse_events.py (livre §9.1.8)
"""

from tkinter import *
def b1_clic(evt) : print('<B1> @ {},{}'.format(evt.x,evt.y))
def b2_clic(evt) : print('<B2> @ {},{}'.format(evt.x,evt.y))
def b3_clic(evt) : print('<B3> @ {},{}'.format(evt.x,evt.y))
def motion(evt) : print('<Motion> @ {},{}'.format(evt.x,evt.y))
def b1_motion(evt) : print('<B1-Motion> @ {},{}'.format(evt.x,evt.y))
def button_release1(evt) : print('<ButtonRelease-1> @ {},{}'.format(evt.x,evt.y))
root = Tk()
root.title('Cliquez-moi !')
CANVAS = Canvas(root,width=300,height=50)
CANVAS.pack()
CANVAS.bind('<Button-1>',b1_clic)
CANVAS.bind('<ButtonRelease-1>',button_release1)
CANVAS.bind('<Button-2>',b2_clic)   # mais je n'écoute pas <ButtonRelease-2>...
CANVAS.bind('<Button-3>',b3_clic)
CANVAS.bind('<Motion>',motion)            
CANVAS.bind('<B1-Motion>',b1_motion)

root.mainloop()

from webbrowser import open as browse
browse('http://tkinter.fdex.eu/doc/event.html')
