#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_2_17.py
03/03/2020
"""
print('Quelques exemples de code du §2.17')
print()

### ligne 231

a = 10                   # a est une variable définie au toplevel

def foo1(x):
    return x + a         # donc a est globale et visible dans foo1

print('>>> foo1(3)',foo1(3),sep='\n--> ')
print('---------------------')

### ligne 237

a = 10

def foo2(x):
    global a            # je préviens que a est globale !
    a = a + 1           # attention : erreur en l'absence de 'global'          
    return x + a

print('>>> foo2(a) + a',foo2(a) + a,sep='\n--> ')       # différent de a + foo2(a)
print('>>> a',a,sep='\n--> ')
print('---------------------')

#### ligne 247

a = 10                            # a est globale

def foo3(x):
    a = 100                       # (*)    a est locale à foo3
    def foo4(y):
        nonlocal a                # référence au a de la ligne (*)
        a = a + 1
        return a + y
    return foo4(3)

print('>>> foo3(3) + a',foo3(3) + a,sep='\n--> ')
print()


