#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_2_20.py
03/03/2020
"""
print('Quelques exemples de code du §2.20')
print()

### ligne 289

m = 10                                     # le contexte de calcul au toplevel
print('>>> lambda x: 2*x-m',
      lambda x: 2*x-m,sep='\n--> ')        # fonction anonyme
print('>>> (lambda x: 2*x-m)(3)',
     (lambda x: 2*x-m)(3),sep='\n--> ')     # valeur de x -> 2x-m en x=3
print('>>> (lambda x,y: 2*x+y)(3,4)',
     (lambda x,y: 2*x+y)(3,4),sep='\n--> ') # valeur de x,y -> 2x+y en x=3,y=4
print('>>> (lambda: 3)()',
     (lambda: 3)(),sep='\n--> ')            # valeur d'une fonction constante
print('---------------------')

### ligne 298

m = 10                 # le contexte de calcul est le toplevel
print('>>> f = lambda x: 2*x-m')           # m est une variable libre de f
f = lambda x: 2*x-m
print('''>>> def foo(y):
        m = 0  # nouvelle variable m locale à foo
        return f(y)''')       # que vaudra m à l'exécution de f(y) ?
def foo(y):
    m = 0              # nouvelle variable m locale à foo
    return f(y)
print('>>> m = m + 1')
m = m + 1              # maintenant m vaut 11 au toplevel
print('>>> foo(3)',foo(3),sep='\n--> ')

### ligne 306

print(">>> 'abs' in dir(__builtins__)\n-->",
      'abs' in dir(__builtins__))
