#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_2_25.py
03/03/2020
"""
__all__ = ['fac']              # pour un 'import *'...

# Quelques exemples de code du §2.25

# ligne 413

def fac(n):                   # calcul de n! pour n entier >= 0
    res = 1
    for i in range(1,n+1):    # pour tout i de 1 jusqu'à n inclus
        res *= i
    return res

if __name__ == '__main__':
    # ligne 406
    print('>>> list(range(10))\n--> {}'.format(list(range(10))))
    print('>>> set(range(10))\n--> {}'.format(set(range(10))))
    r = range(10,1000000000000)    # en attente de produire !
    print('>>> r = range(10,1000000000000)')
    print('>>> len(r)        # temps = 0 sec\n--> {}'.format(len(r)))
    print()
    # ligne 418
    from time import time     # le chronomètre
    start = time() ; p = fac(10000) ; end = time()          # 10000!
    print('>>> p = fac(10000)     # itératif')
    print('>>> len(str(p))   # temps = {:.2f} sec\n--> {}'.format(end-start,len(str(p))))
    print()
    # ligne 427
    print('>>> for (i,x) in enumerate(range(10,20,3)):')
    print("        print((i,x),end=' ')")
    for (i,x) in enumerate(range(10,20,3)) : print((i,x),end=' ')
    
    



