#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_3_2.py
03/03/2020
"""

print('Quelques exemples de code du §3.2')
print()


# ligne 461

s = 'Bonjour se dit \u4f60\u597d'
print('s ==',repr(s),'et type(s) ==',type(s))
print()

# ligne 467

s1 = "Regardez l'éclair !"
print('s1 ==',repr(s1))
s2 = 'Regardez l\'éclair !'
print('s2 ==',repr(s2))
print()

# ligne 473

print('>>> len(s)\n-->',len(s))
print(">>> 'Bonjour se dit ' + '\u4f60\u597d'\n-->",
      repr('Bonjour se dit ' + '\u4f60\u597d'))
print(">>> 'b' in s\n-->",'b' in s)
print(">>> ('B' in s) and ('你' in s)\n-->",('B' in s) and ('你' in s))
print()

# ligne 481

print('>>> s\n-->',repr(s))
print('>>> s[20]')
try:
    print(s[20])
except:
    print('Oups, indice de chaîne illégal')
print(">>> s[2] == s[-15] == 'n'\n-->", s[2] == s[-15])
print('>>> s[3:12]\n-->',repr(s[3:12]))
print('>>> s[-14:-5]\n-->',repr(s[-14:-5]))
print('>>> s[:4]\n-->',repr(s[:4]))
print('>>> s[8:]\n-->',repr(s[8:]))
print('>>> s[:5:2]\n-->',repr(s[:5:2]))
print('>>> s[::-1]\n-->',repr(s[::-1]))
print()

# ligne 501

print('>>> s[11]\n-->',repr(s[11]))
try:
    print(">>> s[11] = 'l'")
    s[11] = 'l'
except:
    print('TypeError: une chaîne est non mutable')
print(">>> s = s[:11] + 'l' + s[12:]")
s = s[:11] + 'l' + s[12:]
print('s\n-->',repr(s))

# ligne 511

print('>>> s2 = s1')
print('>>> s2 == s1\n-->',s2 == s1)
print('>>> s2 is s1\n-->',s2 is s1)
print('>>> s2 = s1[:4] + s1[4:]')
s2 = s1[:4] + s1[4:]
print('>>> s2 is s1\n-->',s2 is s1)
print('>>> s2 == s1\n-->',s2 == s1)
print()

# ligne 821

if '0' < '9' < 'A' < 'Z' < 'a' < 'z':
    print('# Unicode est bien ordonné,')
print('# et par ordre lexicographique :')
print(">>> 'libres' < 'livre'\n-->",'libres' < 'livre')
print()

# ligne 525

print(">>> 'www.unice.fr'.strip('wrf.')\n-->",repr('www.unice.fr'.strip('wrf.')))
print(">>> 'Zip chic'.replace('i','o')\n-->",repr('Zip chic'.replace('i','o')))
print(">>> '23,-356,48'.split(',')\n-->",repr('23,-356,48'.split(',')))
print()

# ligne 531

print('# Les diacritiques :')
print('caractère \u00c9')
print('caractère E\u0301')
