#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_3_3.py
03/03/2020
"""

# Quelques exemples de code du §3.3

def nb_voyelles(s):                # mieux...
    return sum(1 for c in s if c in 'aeiouy')

def nb_voyelles_v1(s):
    res = 0
    for c in s:
        if c in 'aeiouy':          # bon...
            res += 1
    return res

def nb_voyelles_v2(s):
    res = 0
    for i in range(len(s)):        # moins bon...
        if s[i] in 'aeiouy':
            res += 1
    return res

if __name__ == '__main__':
    def verifier(expr,res):     # petit utilitaire sympa...
        resultat = eval(expr)   # dangeureux dans un programme réel ! Voir §3.5
        if resultat != res: 
            print('Bug dans',repr(expr))
        else:
            print('Ok')

    # vérification en silence...
    verifier("nb_voyelles('Les bateaux')",5)
    verifier("nb_voyelles_v1('Les bateaux')",5)
    verifier("nb_voyelles_v2('Les bateaux')",5)
    
    
