#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_3_4.py
03/03/2020
"""

print('Quelques exemples de code du §3.4')
print()

p = 5
q = 3
s = 'addition'
msg = 'Voici une {} : {}+{} = {}'.format(s,p,q,p+q)    # une chaîne formatée
print(repr(msg))
print()

x = 2
print('Expression #{0} : {1} = {2} + 1/{2}'.format(8,'y',x**2))
print()

print('xxxxx{:6}{:5}xxxxx'.format(2021,57))
print('xxxxx{0:6}{1:5}xxxxx'.format(2021,57))
print('décimal {0} - binaire {0:b} - hexa {0:x}'.format(44))
print()

from math import pi
print('pi = {:.3f}        (3 chiffres après la virgule)'.format(pi))
print('pi = {:8f}     (sur 8 caractères en tout)'.format(pi))
print('pi = {:10f}   (6 par défaut après la virgule)'.format(pi))
print('pi = {:10.3f}'.format(pi))
