#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_5_2.py
03/03/2020
"""

print('Quelques exemples de code du §5.2')
print()

# ligne 751

L1 = [6,True,'foo',[5,3],-7.02]     # liste en extension
print('>>> L1\n-->',L1)
print('>>> type(L1)\n-->',type(L1))
print('>>> (L1[0],L1[3])\n-->', (L1[0],L1[3]))     # éléments numéros 0 et 3
L2 = [n for n in range(10)]
print('>>> L2\n-->',L2)
L3 = list(range(10))                # avec le constructeur list
print('>>> L3\n-->',L3)
print('>>> (L2, L2 == L3)\n-->',(L2, L2 == L3))
L4 = [n for n in range(10) if n % 2 == 0]         # en compréhension
print('>>> L4\n-->',L4)

# ligne 763

print('>>> (L1[1],L1[3],L1[-3],L1[-1])\n-->',(L1[1],L1[3],L1[-3],L1[-1]))
try:
    print('>>> L1[5]')
    L1[5]
except:
    print('Indice illégal (IndexError: list index out of range)')
L1[1] = not L1[1]
L1[-1] += 1
print('>>> L1[1] = not L1[1] ; L1[-1] += 1 ; L1\n-->',L1)

# ligne 771

print('>>> L1[1:4]\n-->',L1[1:4])
print('>>> (L1[:3],L1[2:])\n-->',(L1[:3],L1[2:]))
print('>>> L1[::2]\n-->',L1[::2])

print('>>> [L1[-i] for i in range(1,len(L1)+1)]   # (inversion)')
print([L1[-i] for i in range(1,len(L1)+1)])