#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_5_9.py
03/03/2020
"""

print('Quelsues exemples de codes du §5.9 - Exceptions')
print()

# -------------------------------------

d = {'one':1, 'two':2}
try:
    print('>>> print(d[2])')
    print(d[2])                      # déclenchement d'une exception !
except KeyError:
    print("KeyError: Ce n'est pas une clé !")  # récupération d'une KeyError
print('Vu ?')
print()

try:
    print('>>> dbug[2]')
    print(dbug[2]) 
except KeyError:
    print("KeyError: Ce n'est pas une clé !")
except NameError :
    print("NameError: Ce dictionnaire n'existe pas !")
print('Vu ?')
print()

try :
    print('>>> 3 % 0')
    print(3 % 0)
except Exception as e :
    print('Il y a eu une exception de type',type(e).__name__)
print('Vu ?')
print()

def verifier(n) :
    if type(n) != int :
        raise TypeError('On attendait un entier dans verifier !')

try:
    print(">>> verifier('trois')")
    verifier('trois')     # mais on pourrait utiliser un try... pour l'attraper !
except:
    print('TypeError: On attendait un entier dans verifier !')
print('Vu ?')
print()

from webbrowser import open as browse
#browse('https://openclassrooms.com/fr/courses/235344-apprenez-a-programmer-en-python/231688-les-exceptions')
#browse('https://docs.python.org/fr/3.7/tutorial/errors.html')
