#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_6_3.py
03/03/2020
"""

print('Quelques exemples de codes du §6.3 - Fichiers en entrée')
print()

# ligne 1034

def lire_fichier(nom) :
    f_in = open(nom,'r',encoding='UTF-8')
    for ligne in f_in:   # chaque ligne se termine par un '\n'
        print(ligne,end='')
    f_in.close()

print('-------------- table5.txt -----------------')
lire_fichier('table5.txt')
print('-------------------------------------------')
print()

# ligne 1043

f_in = open('table5.txt','r',encoding='UTF-8')
print('>>> f_in.read())      # tout le fichier, longue chaîne')
print(repr(f_in.read()))
f_in.close()
print()

# ligne 1049

f_in = open('table5.txt','r',encoding='UTF-8')
print('>>> f_in.readlines()  # liste des lignes')
print(f_in.readlines())
f_in.close()
print()

# ligne 1054

with open('table5.txt','r',encoding='UTF-8') as f_in:
    print(f_in.readlines())
if f_in.closed : print('Le fichier a bien été fermé !')
print()

# ligne 1060

s = '12, -50, 28, 1025, 7'
print('>>> s\n-->',repr(s))
print(">>> s.split(', ')\n-->",s.split())
print(">>> list(map(int,s.split(', ')))   # map retourne un itérateur\n-->",
      list(map(int,s.split(', '))))
print()

from webbrowser import open as browse
#browse('https://docs.python.org/fr/3/tutorial/inputoutput.html')
