#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

'''
section_9_1_5.py
03/03/2020
'''

print('Quelques exemples de codes du §9.1.5')
print('(les options du gestionnaire de disposition pack)')
print()

from tkinter import *

root = Tk()

# une 'Frame' invisible pour regrouper quelques widgets
frame = Frame(root)
Button(frame,text="mon").pack(side=LEFT)
Button(frame,text="premier").pack(side=LEFT,fill=Y)
Button(frame,text="bateau").pack(fill=X)     # side=TOP par défaut
Button(frame,text="était").pack(side=LEFT)   # fill=None par défaut
Frame(frame,width=15).pack(side=LEFT)        # séparation verticale invisible
Button(frame,text="bleu").pack()
frame.pack()

Frame(root,height=15).pack()                 # séparation horizontale invisible

Label(root,text='pack()').pack()             # expand=0 par défaut

Label(root,text='pack(fill=X)',bg='lightgray').pack(fill=X)

# redimensionnez root pour voir l'effet de 'expand=1' :
Label(root,text='pack(expand=1)',bg='lightgray').pack(expand=1)

root.mainloop()
print('Fini')



from webbrowser import open as browse
#browse('https://www.packtpub.com/application-development/tkinter-gui-application-development-blueprints')
#browse('http://tkinter.fdex.eu/index.html')
#browse('https://www.python-course.eu/tkinter_layout_management.php')


