######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

# rebond.pyde
# Exercice 11.59 b)

from random import randint

GRAV = 1                   # deux constantes physiques
FROT = 0.93                # entre 0 et 1
R = 30                     # rayon de la balle

def setup():               # mise en place
    size(400,400)          # définit width et height
    global x, y, dx, dy
    (x, y) = (randint(30,370), randint(2*R,3*R))
    (dx, dy) = (randint(-20,20), randint(-20,20))
    fill(255,0,0)          # remplissage de la balle en rouge

def presque_fini() :
    return (abs(y - (height - R)) < 1) and (abs(dx) < 0.2)

def draw():                # 1 pas d'animation
    background(255,255,0)  # effacement fond jaune
    global x,y,dx,dy
    ellipse(x,y,2*R,2*R)
    (xs, ys) = (x + dx, y + dy)    # candidat position suivante
    if xs < R:                     # collision mur gauche
        xs = R
        dx = -dx * FROT
    elif xs > width - R :              # collision mur droit
        xs = width - R
        dx = -dx * FROT
        dy = dy * FROT
    elif ys < R:                  # collision mur haut
        ys = R
        dy = -dy * FROT
        dx = dx * FROT
    elif ys > height - R :        # collision au sol
        ys = height - R
        dy = dy - GRAV
        dy = -dy * FROT
        dx = dx * FROT
    else :                        # pas de collision en vue
        (x, y) = (xs, ys)
        dy = dy + GRAV
    if presque_fini() :           # preque... 
        noLoop()
        print('Fini !')
        
    
    
