######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

# smiley.pyde
# Exercice 11.59 a)

def setup():
    size(400,400)        # définit width et height
    (w, h) = (width, height)
    assert w == h, 'Mauvaise dimensions du canevas, choisir w == h'
    smooth()             # pour lisser les courbes
    fill(255,255,0)      # remplissage en jaune
    ellipse(w/2,h/2,w,h) # le disque jaune du visage
    fill(0)              # <==> fill(0,0,0), remplissage en noir
    for i in (1,2):      # les deux yeux noirs
        ellipse(i*w/3,h/3,w/10,h/5)
    noFill()             # plus de remplissage
    strokeWeight(5)      # épaisseur du trait
    arc(w/2,3*w/5,2*w/3,180,0.2,PI-0.2,OPEN)   # la bouche
    save('smiley.png')   # sur disque, dans le répertoire du sketch courant
    
    
