######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

# waveplayer.pyde   -    un premier sketch avec deux UGen
# Fichier exemple pour l'exercice 11.137

add_library('beads')
ac = AudioContext()
 
def setup():                        # ATTENTION AUX OREILLES AVEC UN CASQUE !!!
    size(300,200) ; background(0)   # fenêtre graphique noire
    wp = WavePlayer(ac,440,Buffer.SINE)   # une première UGen (un oscillateur: générateur d'onde)
    g = Gain(ac,1,0.5)                    # une seconde UGen (le gain: un bouton de volume)
    g.addInput(wp)                  # on branche wp sur l'entrée de g
    ac.out.addInput(g);             # on branche g sur la sortie audio
    ac.start()                      # ouverture du canal audio (mono)

def draw():
    print(frameRate)                # histoire de voir le nombre d'img/sec (60 ?)
    
def stop():                         # exécutée à l'arrêt du programme
    ac.stop()                       # coupure de l'audio

    
